package composite.fatturato;

import java.util.*;
import java.io.*;

public class Catalogo
{
	Map<String, CatalogoDitta> ditte;

	public Catalogo()
	{
		ditte = new HashMap<String, CatalogoDitta>();
	}

	public static void main(String[] argv)
	{
		(new Catalogo()).exec(argv);
	}

	void exec(String[] argv)
	{
		try
		{
			Scanner sc = new Scanner(new File("dati.txt"));
			while(sc.hasNextLine())
			{
				String line = sc.nextLine();//leggo nome ditta
				System.out.println("Ditta: <" + line + ">");
				if(line.equals(""))
				{
					break;
				}
				CatalogoDitta cd = ditte.get(line);
				if(cd == null)//nuova ditta
				{
					cd = new CatalogoDitta(line);
					ditte.put(line, cd);
				}
				String padre = sc.nextLine();
				if(padre.equals(""))
				{
					padre = null;
				}

				String nomeFatt = sc.nextLine();
				Fatturabile fatt = null;

				try
				{
					Class clazz = Class.forName(nomeFatt);
					fatt = (Fatturabile)clazz.newInstance();
				}
				catch(ClassNotFoundException cnfe)
				{
					cnfe.printStackTrace();
					continue;
				}
				catch(IllegalAccessException iae)
				{
					iae.printStackTrace();
					continue;
				}
				catch(InstantiationException ie)
				{
					ie.printStackTrace();
					continue;
				}

				if(fatt instanceof Prodotto)
				{
					((Prodotto)fatt).fatturato = sc.nextDouble();
				}

				cd.addFatturabile(fatt, padre);

				System.out.println(ditte);
			}
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			System.exit(1);
		}

		System.out.println(ditte);

		/*
		while(true)
		{
		}
		*/
	}
}
