package composite.fatturato;

import java.util.*;

public class CatalogoDitta
implements Interrogabile, Gestibile
{
	Map<String, Fatturabile> fatturabili;
	String nomeDitta;

	//per debug
	Fatturabile root;
	//fine debug

	public CatalogoDitta(String nome)
	{
		nomeDitta = nome;
		fatturabili = new HashMap<String, Fatturabile>();
		root = null;
	}

	public CatalogoDitta()
	{
		this("temporaneo");
	}

	public String toString()
	{
		if(fatturabili == null)
		{
			System.out.println("AARRGGHH!!");
		}
		return nomeDitta + ": " + fatturabili.toString();
	}

	//Interrogabile
	public double getFatturato(String name)
	{
		Fatturabile f = fatturabili.get(name);
		if(f == null)
		{
			System.err.println("Nome <" + name + "> non presente nel catalogo");
			return -1;
		}
		return f.getFatturato();
	}

	//Gestibile
	public void addFatturabile(Fatturabile f, String np)
	{
		if(np == null || np.equals(""))//sto settando la radice
		{
			if(root != null)// la radice e' gia' settata
			{
				throw new UnsettableRootException("La root ha gia' un valore");
			}

			root = f;
		}
		else
		{
			System.out.println("Cerco: " + np);
			Fatturabile fp = fatturabili.get(np);
			if(! (fp instanceof FamigliaProdotti))
			{
				throw new IllegalOperationException("Fatturabile <" + np + "> e' un prodotto: " + fp.toString());
			}
			FamigliaProdotti famigliaProdotti = (FamigliaProdotti)fp;
			if(f instanceof Prodotto)
			{
				famigliaProdotti.addProdotto((Prodotto)f);
			}
			else if(f instanceof FamigliaProdotti)
			{
				famigliaProdotti.addSottoFamiglia((FamigliaProdotti)f);
			}
			else//non deve succedere
			{
				System.err.println(f.toString() + " non e' ne' Prodotto ne' FamigliaProdotti");
			}
		}

		fatturabili.put(f.getClass().getName(), f);
	}
}
