package composite.fatturato;

import java.util.*;

public class Spazzolini
extends FamigliaProdotti
{
	List<Prodotto> prodotti;
	List<FamigliaProdotti> famiglie;

	String name;

	public Spazzolini()
	{
		prodotti = new LinkedList<Prodotto>();
		famiglie = new LinkedList<FamigliaProdotti>();
	}

	public List<Prodotto> getProdotti()
	{
		List<Prodotto> retval = new LinkedList<Prodotto>();
		retval.addAll(prodotti);
		return retval;
	}

	public List<FamigliaProdotti> getSottoFamiglie()
	{
		List<FamigliaProdotti> retval = new LinkedList<FamigliaProdotti>();
		retval.addAll(famiglie);
		return retval;
	}

	void addProdotto(Prodotto p)
	{
		prodotti.add(p);
	}

	void addSottoFamiglia(FamigliaProdotti fp)
	{
		famiglie.add(fp);
	}

	Prodotto removeProdotto(String name)
	{
		ListIterator<Prodotto> iter = prodotti.listIterator();
		while(iter.hasNext())
		{
			Prodotto tmp = iter.next();
			if(tmp.name.equals(name))
			{
				iter.remove();
				return tmp;
			}
		}
		return null;
	}

	FamigliaProdotti removeFamigliaProdotti(String name)
	{
		ListIterator<FamigliaProdotti> iter = famiglie.listIterator();
		while(iter.hasNext())
		{
			FamigliaProdotti tmp = iter.next();
			if(tmp.name.equals(name))
			{
				iter.remove();
				return tmp;
			}
		}
		return null;
	}

	public double getFatturato()
	{
		double retval = 0;
		ListIterator<Prodotto> iter = prodotti.listIterator();
		while(iter.hasNext())
		{
			retval += iter.next().getFatturato();
		}

		ListIterator<FamigliaProdotti> iter2 = famiglie.listIterator();
		while(iter.hasNext())
		{
			retval += iter.next().getFatturato();
		}

		return retval;
	}

	public String toString()
	{
		return super.toString() + ": Prodotti->" + prodotti.toString() + "; Famiglie->" + famiglie.toString();
	}
}
